#include <GL/gl.h>
#include <msp/gl/texture.h>
#include <msp/gltk/button.h>
#include <msp/gltk/column.h>
#include <msp/gltk/row.h>
#include <msp/input/keys.h>
#include "designer.h"
#include "input.h"

using namespace std;
using namespace Msp;

InputDialog::InputDialog(Designer &d, const string &title, const string &text):
	designer(d)
{
	set_layout(new GLtk::Layout);
	GLtk::Column col(*layout);

	GLtk::Label *lbl;
	add(*(lbl=new GLtk::Label(title)));
	lbl->set_style("title");

	add(*(entry=new GLtk::Entry(text)));
	entry->set_edit_size(60, 1);

	GLtk::Button *btn;

	{
		GLtk::Row row(*layout);
		row.split();
		add_button(*(btn=new GLtk::Button("Cncl")), 0);
		btn->set_style("red");

		add_button(*(btn=new GLtk::Button("OK")), 1);
		btn->set_style("green");
	}

	entry->set_focus();
}

void InputDialog::key_press(unsigned key, unsigned mod)
{
	if(key==Msp::Input::KEY_ENTER)
		response(1);
	else if(key==Msp::Input::KEY_ESC)
		response(0);
	else
		Dialog::key_press(key, mod);
}

void InputDialog::on_response(int code)
{
	if(code)
		signal_accept.emit(entry->get_text());
}
