#include "designer.h"
#include "layoutbar.h"

using namespace Msp;

Layoutbar::Layoutbar(Designer &designer):
	Toolbar("Layout")
{
	GLtk::Button *btn;

	pnl_content->add(*(btn = new GLtk::Button("Load")));
	btn->set_tooltip("Load layout (not implemented)");

	pnl_content->add(*(btn = new GLtk::Button("Save")));
	btn->set_tooltip("Save current layout (W)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::save));

	pnl_content->add(*(btn = new GLtk::Button("SVG")));
	btn->set_tooltip("Export layout as SVG (V)");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::svg_export));

	pnl_content->add(*(btn = new GLtk::Button("Quit")));
	btn->set_style("red");
	btn->set_tooltip("Exit Designer");
	btn->signal_clicked.connect(sigc::mem_fun(&designer, &Designer::quit));
}
