#ifndef ZONEBAR_H_
#define ZONEBAR_H_

#include <msp/gltk/dropdown.h>
#include "toolbar.h"

class Designer;

class Zonebar: public Toolbar, public sigc::trackable
{
private:
	Designer &designer;
	Msp::GLtk::BasicListData<std::string> groups;
	Msp::GLtk::Dropdown *drp_groups;
	Msp::GLtk::FunctionListData<R2C2::Zone *> zones;
	Msp::GLtk::Dropdown *drp_numbers;

public:
	Zonebar(Designer &);

private:
	void track_chain_added(R2C2::TrackChain &);
	void track_chain_removed(R2C2::TrackChain &);
	void zone_renamed(R2C2::Zone &, const std::string &);
	void group_selected(unsigned);
	void number_selected(unsigned);
	void delete_zone_clicked();
};

#endif
