#include "packets.h"
#include "protocol.h"

namespace R2C2 {

Protocol::Protocol()
{
	add<DriverStatePacket>() (&DriverStatePacket::power)
		(&DriverStatePacket::halt);
	add<EmergencyPacket>() (&EmergencyPacket::message);
	add<TrainInfoPacket>() (&TrainInfoPacket::address)
		(&TrainInfoPacket::loco_type) (&TrainInfoPacket::name);
	add<TrainControlPacket>() (&TrainControlPacket::address)
		(&TrainControlPacket::control) (&TrainControlPacket::value);
	add<TrainFunctionPacket>() (&TrainFunctionPacket::address)
		(&TrainFunctionPacket::functions);
	add<TrainAIControlPacket>() (&TrainAIControlPacket::address)
		(&TrainAIControlPacket::target_speed) (&TrainAIControlPacket::reverse);
	add<TrainStatusPacket>() (&TrainStatusPacket::address)
		(&TrainStatusPacket::status);
	add<RouteInfoPacket>() (&RouteInfoPacket::name);
	add<TrainRoutePacket>() (&TrainRoutePacket::address)
		(&TrainRoutePacket::route);
	add<ErrorPacket>() (&ErrorPacket::message);
}

} // namespace R2C2
